/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 */

/*
 * test_locale.c
 * -------------
 *
 * Test the il8n support
 */

#include <stdio.h>

#include "impulse/util/text.h"
#include "impulse/util/main.h"


impulse_int main(impulse_int argc, 
		 impulse_char *argv[])
{
  impulse_char *str1, *str2;
  
  impulse_init(argc, argv, "locale");
  impulse_command_parse();

  str1 = impulse_unistring_to_utf(impulse_app_locale(), 8, 0);
  str2 = impulse_unistring_to_utf(impulse_app_charset(), 8, 0);
  printf("Locale: %s, Charset: %s\n", str1, str2);
  impulse_free(str1);
  impulse_free(str2);

  impulse_cleanup();
  
  return 0;
}


/* End of file */
