/*                                                                |- Impulse -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the Impulse utility library
 * for Impulse. (Part of the ROWS distribution)
 *
 * The Initial Developer of the Original Code is
 * Daniel Berrange. Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * channel_int.h
 * -------------
 *
 * Communication channel functions
 */


#ifndef __impulse_comms_channel_int_h
#define __impulse_comms_channel_int_h

#include <impulse/comms/channel.h>
#include <impulse/util/hash.h>

/*                            ======--------======                           */
typedef struct __p_impulse_channel_service *_p_impulse_channel_service;
typedef struct __p_impulse_channel *_p_impulse_channel;


struct __p_impulse_channel_service
{
  impulse_ubyte incoming;
  impulse_ubyte outgoing;
  
  impulse_bool init:1;
  impulse_bool auth:1;
  impulse_bool active:1;

  struct _impulse_channel_version version;
  
  impulse_channel_service external;
};


struct __p_impulse_channel
{
  impulse_message message;
  void *offset;
  impulse_int need;

  impulse_int eventid;
  impulse_hash services;
  impulse_ubyte nincoming;
  impulse_ubyte noutgoing;
  _p_impulse_channel_service *incoming;
  _p_impulse_channel_service *outgoing;
};


#endif

/* End of file */
