/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * child_int.h
 * -----------
 *
 * Contained widget internal information
 */

#ifndef __impulse_rows_child_int_h
#define __impulse_rows_child_int_h

#include <impulse/rows/child.h>
#include <impulse/rows/container.h>

#ifdef __cplusplus
extern "C" {  
#endif

typedef struct {
  ROWS_drawable  draw;
  ROWS_style    style;

  ROWS_style_active_type active;

  ROWS_point     border;
  ROWS_point     offset;

  impulse_int visible:1;
  impulse_int actualised:1;
  impulse_int realised:1;

  ROWS_container container;
  ROWS_container lock_container;
  /* (In case the widget gets reparented while locked) */

  int                 activation;
  ROWS_child_state    state;
  impulse_int               select_group;

  void *int_data;
} _p_ROWS_child_data;

/*                            ======--------======                           */

extern int  _p_ROWS_child_ID;
extern int  _p_ROWS_child_type;

/*                            ======--------======                           */

/* Functions used internally by ROWS_container */

extern void ROWS_child_set_container(ROWS_child child,
				     ROWS_container container);
extern void ROWS_child_set_drawable(ROWS_child child,
				    ROWS_drawable drawable);

/* Functions used by architecture-specific routines */

extern void _p_ROWS_child_int_setup  (ROWS_widget   *widget,
				      ROWS_drawable  drawable);
extern void _p_ROWS_child_int_destroy(_p_ROWS_child_data **data);

extern void _p_ROWS_child_int_container(ROWS_child     child,
					ROWS_container container);

extern void _p_ROWS_child_int_set_realised(ROWS_child child,
					   impulse_bool realised);
extern void _p_ROWS_child_int_set_visible(ROWS_child child,
					  impulse_bool visible);
extern void _p_ROWS_child_int_set_actualised(ROWS_child child,
					     impulse_bool actual);

extern void _p_ROWS_child_int_update  (ROWS_child child);

#ifdef __cplusplus
}
#endif

#endif
