/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the ROWS widget library
 * for Impulse.
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter. Portions created by Andrew Hunter
 * are Copyright (C) 1999 Andrew Hunter.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * comms_int.h
 * -----------
 *
 * ROWS generic communication interface
 */

#ifndef __impulse_rows_comms_int_h
#define __impulse_rows_comms_int_h

#include <impulse/rows/comms.h>
#include <impulse/comms/transport_int.h>

#ifdef __cplusplus
extern "C" {  
#endif

extern impulse_transport_module ROWS_comms_transport_module;
  
  
void ROWS_comms_init(void);
void ROWS_comms_cleanup(void);
  
void ROWS_comms_create(impulse_transport transport);
void ROWS_comms_destroy(impulse_transport transport);

/* Event functions */
impulse_int ROWS_comms_handle(impulse_transport transport,
			      impulse_transport_handler func,
			      void *edata);
impulse_int ROWS_comms_unhandle(impulse_transport transport);

/* Name resolution stuff */
impulse_int ROWS_comms_lookup(impulse_transport transport,
			      impulse_unistring name,
			      impulse_unistring *address);
impulse_int ROWS_comms_rlookup(impulse_transport transport,
			       impulse_unistring address,
			       impulse_unistring *name);
  
/* Connection functions */
impulse_int ROWS_comms_open(impulse_transport transport,
			    impulse_unistring local,
			    impulse_unistring remote);
impulse_int ROWS_comms_accept(impulse_transport transport,
			      impulse_transport *client);
impulse_int ROWS_comms_close(impulse_transport transport);
impulse_int ROWS_comms_active(impulse_transport transport);

/* Data transfer functions */
impulse_int ROWS_comms_pending(impulse_transport transport);
impulse_int ROWS_comms_send(impulse_transport transport,
			    impulse_byte *buffer,
			    impulse_uint size,
			    impulse_unistring address);
impulse_int ROWS_comms_receive(impulse_transport transport,
			       impulse_byte *buffer,
			       impulse_uint size,
			       impulse_unistring *address);

#ifdef __cplusplus
}
#endif

#endif
