/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * constructor_int.h
 * -----------------
 *
 * A widget used for constructing complex user interface artifacts :)
 * (Or, put more simply, Charles's guideline widget idea)
 */

/*
 * A constructors innards
 */

#ifndef __impulse_rows_constructor_int_h
#define __impulse_rows_constructor_int_h

#include <impulse/rows/constructor.h>

#ifdef __cplusplus
extern "C" {  
#endif

typedef struct {
  microns position;         /* Absolute position */
  int     position_unknown; /* 1 if position currently unknown */
  int     loop_check;       /* Watch out for loops! */
  int     attached;         /* Can't destroy if attached to a widget... */

  ROWS_constructor_orientation orient;
  ROWS_constructor_type        type;
  int                          lower;
  int                          upper;
  float                        pos;   /* Relative position */

  ROWS_constructor_func        func;
  void                        *func_data;
} _p_ROWS_guideline;

typedef struct _p_ROWS_constructor_child {
  int left, right, top, bottom;

  ROWS_child widget;

  struct _p_ROWS_constructor_child *next;
} _p_ROWS_constructor_child;

typedef struct {
  int no_guidelines;

  _p_ROWS_guideline *array;

  _p_ROWS_constructor_child *children;

  void *temp_data;
} _p_ROWS_constructor_data;

#ifdef __cplusplus
}
#endif

#endif

