/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * screen.h
 * --------
 *
 * Drawable implementation for screens
 */

#ifndef __impulse_rows_screen_xwin_h
#define __impulse_rows_screen_xwin_h

#include <impulse/rows/screen.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#ifdef __cplusplus
extern "C" {  
#endif

/*                            ======--------======                           */

typedef struct _p_ROWS_X_screen_region_stack {
  Region     clip;
  struct _p_ROWS_X_screen_region_stack *next;
} *_p_ROWS_X_screen_region_stack;


typedef struct {
  GC        maingc;
  Drawable  drawable;
  Visual   *visual;
  Display  *display;
  Colormap  cmap;

  int rshift, gshift, bshift;

  int use_shm;

  Region clip;
  _p_ROWS_X_screen_region_stack regions;
} _p_ROWS_X_screen_data;

struct _ROWS_X_colour_data {
  XColor realcolour;

  impulse_int r,g,b;
  impulse_int was_pixel;

  struct {
    Display  *display;
    Colormap  cmap;
    Visual   *visual;
  } xdata;
};

typedef struct
{
  XGCValues     GCvalues;
  unsigned long value_mask;
  Font          this_font;
  GC            private_gc;

  int           use_dashes;
  char         *dashes;
  int           n_dashes;
  int           offset;
} _p_ROWS_X_brush_data;

/*                            ======--------======                           */

#ifdef __cplusplus
}
#endif

#endif
