/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * widget_int.h
 * ------------
 *
 * Widget internal information
 */

#ifndef __impulse_rows_widget_int_h
#define __impulse_rows_widget_int_h

#include <impulse/rows/widget.h>
#include <impulse/util/thread.h>

#ifdef __cplusplus
extern "C" {  
#endif

struct _p_ROWS_widget_notify_list {
  ROWS_widget_destroy_notify_func    func;
  void                              *destroy_data;

  struct _p_ROWS_widget_notify_list *next;
};

typedef struct {
  int hierarchy_depth;

#if USE_THREADS
  impulse_mutex mutex;
#endif

  struct _p_ROWS_widget_notify_list *destroy_notify;
} _p_ROWS_widget_data;

typedef struct {
  ROWS_widget              *widget;

  int                       type_id;
  ROWS_widget_destroy_func  destroy;
} _p_ROWS_widget_info;

#ifdef __cplusplus
}
#endif

#endif
