/*                                                                |- Impulse -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the Impulse utility library
 * for Impulse. (Part of the ROWS distribution)
 *
 * The Initial Developer of the Original Code is
 * Daniel Berrange. Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * iterator.h
 * ----------
 *
 * Collection iterators
 */

#ifndef __impulse_util_iterator_h
#define __impulse_util_iterator_h

#include <impulse/util/setup.h>

#ifdef __cplusplus
extern "C" {  
#endif

/*                            ======--------======                           */

/* iteratoring data structures */

typedef struct _impulse_iterator *impulse_iterator;

struct _impulse_iterator_funcs
{
  void (*destroy)(void *);
  impulse_bool (*eof)(void *);
  void (*reset)(void *);
  void *(*next)(void *);
};

typedef struct _impulse_iterator_funcs *impulse_iterator_funcs;

/*                            ======--------======                           */

/* iteratoring functions */

impulse_iterator impulse_iterator_create(impulse_iterator_funcs funcs,
					 void *data);
void impulse_iterator_destroy(impulse_iterator iterator);

impulse_bool impulse_iterator_eof(impulse_iterator iterator);
void impulse_iterator_reset(impulse_iterator iterator);
void *impulse_iterator_next(impulse_iterator iterator);

#ifdef __cplusplus
}
#endif

#endif

