/*                                                                |- Impulse -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 */

/*
 * mapping_int.h
 * -------------
 *
 * Data structures used to represent mappings between the Unicode 
 * character set and various 8bit character encodings
 */

#ifndef __impulse_util_mapping_int_h
#define __impulse_util_mapping_int_h

#include <impulse/util/mapping.h>
  
#ifdef __cplusplus
extern "C" {  
#endif

  /*                            ======--------======                           */
  
  
  struct _impulse_mapping_engine
  {
    impulse_bool type;
    struct _impulse_mapping_engine_data
    {
      impulse_unichar *to;
      impulse_char **from;
    } data;
    struct _impulse_mapping_engine_func
    {
      impulse_unistring(*to)(impulse_char *);
      impulse_char *(*from)(impulse_unistring);
    } func;
  };
  
  typedef struct _impulse_mapping_engine *impulse_mapping_engine;
  
#ifdef __cplusplus
}
#endif

#endif
