/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * thread_win32.c
 * --------------
 *
 * Impulse threading routines
 * Win32 Threads implementation
 */


/*                            ======--------======                           */

#error "Feck arse, not finished yet"

/* Thread function defintions */

void impulse_thread_init(void)
{
}


void impulse_thread_cleanup(void)
{ 
}



impulse_thread impulse_thread_create(impulse_thread_main func,
					    void *argument)
{
  DWORD id;
  HANDLE handle;
  handle = CreateThread(NULL, 0, func, argument, 0, &id);

  if (handle == -1L)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create new thread", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
}


impulse_thread impulse_thread_create_detach(impulse_thread_main func,
					    void *argument)
{
  DWORD id;
  HANDLE handle;
  handle = CreateThread(NULL, 0, func, argument, 0, &id);
  
  if (handle == -1L)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create new thread", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
}


void impulse_thread_exit(void *status)
{
  ExitThread((DWORD)status);
}


void impulse_thread_join(impulse_thread t, void **status)
{
  if (WaitForSingleObject(t, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot join thread", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for thread failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  if (!GetExitCodeThread(t, (LPDWORD)status))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot join thread", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Cannot determine exit status", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
}


impulse_thread impulse_thread_self(void)
{
  impulse_thread t;
  t = GetCurrentThread();
  
  if (t == -1L)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot determine 'self' thread", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
}


impulse_bool impulse_thread_same(impulse_thread a,
				 impulse_thread b)
{
  return (a == b);
}


void impulse_thread_nap(impulse_int secs,
			impulse_int usecs)
{
  Sleep((secs * 1000) + (usecs / 1000));
}


void impulse_thread_yield(void)
{
  Sleep(0);
}


/* Mutex functions */

static void _p_impulse_mutex_create_static(impulse_mutex mutex)
{
  /* lock */
  if (!(*mutex))
  {
    if (!(*mutex = CreateMutex(NULL, 0, NULL)))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot create mutex", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
      impulse_unistring_destroy(desc);
    }
  }
  /* Unlock */
}


impulse_mutex impulse_mutex_create(void)
{
  impulse_mutex mutex = impulse_alloc(sizeof(impulse_mutex_impl));

  if (!(*mutex = CreateMutex(NULL, 0, NULL)))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create mutex", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
  
  return mutex;
}


impulse_mutex impulse_mutex_create_recursive(void)
{
  impulse_mutex mutex = impulse_alloc(sizeof(impulse_mutex_impl));
  
  if (!(*mutex = CreateMutex(NULL, 0, NULL)))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create recursive mutex", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
  
  return mutex;
}


void impulse_mutex_lock(impulse_mutex mutex)
{
  if (!(*mutex))
    _p_impulse_mutex_create_static(mutex);
  
  if (WaitForSingleObject(*mutex, INFINITE) != WAIT_OBJECT_0)
  {  
    impulse_unistring desc = impulse_unistring_create_utf("Cannot lock mutex", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
}


impulse_bool impulse_mutex_trylock(impulse_mutex mutex)
{
  DWORD status;
  if (!(*mutex))
    _p_impulse_mutex_create_static(mutex);
  
  status = WaitForSingleObject(*mutex, 0);
  
  if (status == WAIT_TIMEOUT)
    return 0;
  else if (status != WAIT_OBJECT_O)
  {  
    impulse_unistring desc = impulse_unistring_create_utf("Cannot trylock mutex", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  return 1;
}


void impulse_mutex_unlock(impulse_mutex mutex)
{
  if (!(*mutex))
    _p_impulse_mutex_create_static(mutex);
  
  if (!ReleaseMutex(*mutex))
  { 
    impulse_unistring desc = impulse_unistring_create_utf("Cannot unlock mutex", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
}


void impulse_mutex_destroy(impulse_mutex mutex)
{
  CloseHandle(*mutex);
  impulse_free(mutex);
}

impulse_mutex_static global_lock = IMPULSE_MUTEX_CREATE_STATIC;

void impulse_mutex_f_global_lock(void)
{
  impulse_mutex_lock(&global_lock);
}

void impulse_mutex_f_global_unlock(void)
{
  impulse_mutex_unlock(&global_unlock);
}



/* Condition variable functions */

static void _p_impulse_cond_create_static(impulse_cond cond)
{
  /* Lock */
  if (!(cond->sema))
  {
    cond->waiters = 0;
    if (!(cond->waiters_mutex = CreateMutex(NULL, 0, NULL)))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot create condition", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Create mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
    if (!(cond->sema = CreateSemaphore(NULL, 0, 0x7FFFFFF, NULL)))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot create condition", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Create semaphore failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
  /* Unlock */
}



impulse_cond impulse_cond_create(void)
{
  impulse_cond cond = impulse_alloc(sizeof(impulse_cond_impl));
  
  cond->waiters = 0;
  if (!(cond->waiters_mutex = CreateMutex(NULL, 0, NULL)))
  {  
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Create mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
    
  if (!(cond->sema = CreateSemaphore(NULL, 0, 0x7FFFFFF, NULL)))
  { 
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Create semaphore failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }

  return cond;
}


void impulse_cond_signal(impulse_cond cond)
{
  if (!(cond->sema))
    _p_impulse_cond_create_static(cond);
  
  if (WaitForSingleObject(cond->waiters_mutex, INFINITE) != WAIT_OBJECT_O)
  {  
    impulse_unistring desc = impulse_unistring_create_utf("Cannot signal condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }

  if (cond->waiters > 0)
  {
    if (!ReleaseSemaphore(cond->sema, 1, 0))
    {  
      impulse_unistring desc = impulse_unistring_create_utf("Cannot signal condition", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release semaphore failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
  cond->waiters--;
  if (!ReleaseMutex(cond->waiters_mutex))
  { 
    impulse_unistring desc = impulse_unistring_create_utf("Cannot signal condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
}


void impulse_cond_broadcast(impulse_cond cond)
{
  if (!(cond->sema))
    _p_impulse_cond_create_static(cond);
  
  if (WaitForSingleObject(cond->waiters_mutex, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot broadcast condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  if (cond->waiters > 0)
  {
    if (!ReleaseSemaphore(cond->sema, cond->waiters, 0))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot broadcast condition", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release semaphore failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
  cond->waiters = 0;
  if (!ReleaseMutex(cond->waiters_mutex))
  { 
    impulse_unistring desc = impulse_unistring_create_utf("Cannot broadcast condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
}


void impulse_cond_wait(impulse_cond cond,
		       impulse_mutex mutex)
{
  if (!(cond->sema))
    _p_impulse_cond_create_static(cond);

  if (WaitForSingleObject(cond->waiters_mutex, INFINITE) != WAIT_OBJECT_O)
  {  
    impulse_unistring desc = impulse_unistring_create_utf("Cannot wait on condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  cond->waiters++;
  if (!ReleaseMutex(cond->waiters_mutex))
  {    
    impulse_unistring desc = impulse_unistring_create_utf("Cannot wait on condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  impulse_mutex_unlock(mutex);
  
  if (WaitForSingleObject(cond->sema, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot wait on condition", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for semaphore failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  impulse_mutex_lock(mutex);
}


void impulse_cond_destroy(impulse_cond  cond)
{
  CloseHandle(cond->waiters_mutex);
  CloseHandle(cond->sema);
  impulse_free(cond);
}


/* Read/write mutexes */


void _p_impulse_rwlock_create_static(impulse_rwlock lock)
{
  /* Lock */
  if (!(lock->mutex))
  {
    if (!(lock->mutex = CreateMutex(NULL, 0, NULL)))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot create rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Create mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
    if (!(lock->readers = CreateSemaphore(NULL, 0, 0x7FFFFFF, NULL)))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot create rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Create semaphore failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
    if (!(lock->writers = CreateSemaphore(NULL, 0, 0x7FFFFFF, NULL)))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot create rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Create semaphore failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
  /* Unlock */
}


impulse_rwlock impulse_rwlock_create (void)
{
  impulse_rwlock lock = impulse_alloc(sizeof(impulse_rwlock_impl));
  
  lock->counter = 0;
  lock->nreaders = 0;
  lock->nwriters = 0;
  
  if (!(lock->mutex = CreateMutex(NULL, 0, NULL)))
  { 
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Create mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  if (!(lock->readers = CreateSemaphore(NULL, 0, 0x7FFFFFF, NULL)))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Create semaphore failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  if (!(lock->writers = CreateSemaphore(NULL, 0, 0x7FFFFFF, NULL)))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Create semaphore failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }

  return lock;
}


void impulse_rwlock_read(impulse_rwlock lock)
{
  if (WaitForSingleObject(lock->mutex, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot read rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  if (lock->counter >= 0)
  {
    lock->counter++;
    if (!ReleaseMutex(lock->mutex))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot read rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
  else
  {
    lock->nreaders++;
    if (!ReleaseMutex(lock->mutex))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot read rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
    if (!(WaitForSingleObject(lock->readers, INFINITE) != WAIT_OBJECT_O))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot read rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Wait for semaphore failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
}


impulse_bool impulse_rwlock_tryread(impulse_rwlock lock)
{
  if (WaitForSingleObject(lock->mutex, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot tryread rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  if (lock->counter >= 0)
  {
    lock->counter++;
    if (!ReleaseMutex(lock->mutex))
    {  
      impulse_unistring desc = impulse_unistring_create_utf("Cannot tryread rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
    return 1;
  }
  else
    return 0;
}


void impulse_rwlock_write(impulse_rwlock lock)
{
  if (WaitForSingleObject(lock->mutex, INFINITE) != WAIT_OBJECT_O)
  {  
    impulse_unistring desc = impulse_unistring_create_utf("Cannot write rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  if (lock->counter == 0)
  {
    lock->counter = -1;
    if (!ReleaseMutex(lock->mutex))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot write rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
  else
  {
    lock->nwriters++;
    if (!ReleaseMutex(lock->mutex))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot write rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
    if (!(WaitForSingleObject(lock->writers, INFINITE) != WAIT_OBJECT_O))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot write rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Wait for semaphore failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
  }
}


impulse_bool impulse_rwlock_trywrite(impulse_rwlock lock)
{
  if (WaitForSingleObject(lock->mutex, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot trywrite rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  if (lock->counter == 0)
  {
    lock->counter = -1;
    if (!ReleaseMutex(lock->mutex))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot trywrite rwlock", 8);
      impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
      impulse_unistring_destroy(msg);
      impulse_unistring_destroy(desc);
    }
    return 1;
  }
  else
    return 0;
}


void impulse_rwlock_unlock(impulse_rwlock lock)
{
  if (WaitForSingleObject(lock->mutex, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot unlock rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Wait for mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
  
  if (lock->counter == -1)
    lock->counter = 0;
  else if (lock->counter > 0)
    lock->counter--;
    
  if (!lock->counter)
  {
    if (lock->nwriters)
    {
      if (!ReleaseSemaphore(lock->writers, 1, 0))
      {
        impulse_unistring desc = impulse_unistring_create_utf("Cannot unlock rwlock", 8);
        impulse_unistring msg = impulse_unistring_create_utf("Release semaphore failed", 8);
        impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
        impulse_unistring_destroy(msg);
        impulse_unistring_destroy(desc);
      }
      ;
      lock->counter = -1;
      lock->nwriters--;
    }
    else if (lock->nreaders)
    {
      if (!ReleaseSemaphore(lock->readers, lock->nreaders, 0))
      {
        impulse_unistring desc = impulse_unistring_create_utf("Cannot unlock rwlock", 8);
        impulse_unistring msg = impulse_unistring_create_utf("Release semaphore failed", 8);
        impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
        impulse_unistring_destroy(msg);
        impulse_unistring_destroy(desc);
      }
      lock->counter = lock->nreaders;
      lock->nreaders = 0;
    }
  }
  
  if (!ReleaseMutex(lock->mutex))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot unlock rwlock", 8);
    impulse_unistring msg = impulse_unistring_create_utf("Release mutex failed", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, msg);
    impulse_unistring_destroy(msg);
    impulse_unistring_destroy(desc);
  }
}


void impulse_rwlock_destroy(impulse_rwlock lock)
{
  CloseHandle(lock->mutex);
  CloseHandle(lock->readers);
  CloseHandle(lock->writers);
  impulse_free(lock);
}


/* Semaphores */


static void _p_impulse_sema_create_static(impulse_sema sem)
{
  /* Lock */
  if (!(*sem))
  {
    if (!(*sem = CreateSemaphore(NULL, 0, 0x7FFFFFF, NULL)))
    {
      impulse_unistring desc = impulse_unistring_create_utf("Cannot create semaphore", 8);
      impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
      impulse_unistring_destroy(desc);
    }
  }
  /* Unlock */
}


impulse_sema impulse_sema_create (impulse_int value)
{
  impulse_sema sem = impulse_alloc(sizeof(impulse_sema_impl));
  
  if (!(*sem = CreateSemaphore(NULL, value, 0x7FFFFFF,NULL)))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot create semaphore", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
  
  return sem;
}


void impulse_sema_wait(impulse_sema sem)
{
  int status;
  
  if (!(*sem))
    _p_impulse_sema_create_static(sem);
  
  if (WaitForSingleObject(*sem, INFINITE) != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot wait on semaphore", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
}


impulse_bool impulse_sema_trywait(impulse_sema sem)
{
  int status;
  
  if (!(*sem))
    _p_impulse_sema_create_static(sem);

  status = WaitForSingleObject(*sem, 0);
  if (status == WAIT_TIMEOUT)
    return 0;
  else if (status != WAIT_OBJECT_O)
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot trywait on semaphore", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
  return 1;
}


void impulse_sema_post(impulse_sema sem)
{
  if (!(*sem))
    _p_impulse_sema_create_static(sem);

  if (!ReleaseSemaphore(*sem, 1, 0))
  {
    impulse_unistring desc = impulse_unistring_create_utf("Cannot post to semaphore", 8);
    impulse_error_raise(IMPULSE_ERROR_EMERGENCY, desc, NULL);
    impulse_unistring_destroy(desc);
  }
}


void impulse_sema_destroy(impulse_sema sem)
{
  CloseHandle(*sem);
}


/* End of file */
